#ifndef _TKOL1
#define _TKOL1
#include <stdlib.h>
#include <string.h>
#include "abstr.h"
typedef TAbstr T;
class TKol1
	 { public:
		T **elem;  //elem jako wskaznik dla dynamicznej tablicy wskaznikow T
		int ile;
		int biezacy;
		TKol1() {elem=NULL; ile = 0; biezacy=0;}
	 ~TKol1(){};

 int Pusty(T** p)  {return p == NULL;}
 void Zeruj() {biezacy=0;}

	int Zmien(int delta)
	 { T** pom;
			pom = (T**)realloc(elem,sizeof(void*)*(ile+delta));
		 if (pom)
			elem=pom;
			return !Pusty(pom);
	 }

	int Zakres(int ktory)
	{ return ktory>=0 && ktory<ile;}

	int Wstaw(T* dane, int ktory)
	 {
		 if (ktory <0 || ktory>ile) return 0;
		 memmove( &elem[ktory+1], &elem[ktory], (ile-ktory)*sizeof(void *) );
		 elem[ktory]=dane;
		 ile++;
		 return 1;
		}

	 int Usun(int ktory)
		{
		 if (!Zakres(ktory)) return 0;
		 delete (elem[ktory]);
		 ile--;
		 memmove( &elem[ktory], &elem[ktory+1], (ile-ktory)*sizeof(void *) );
		 return 1;
		}

	 void _Usun(int ktory)
		{
		 Usun(ktory);
		 if (ile==0) Usun_kolekcje();
		 else	Zmien(0);
		}
	 
	 T* operator++(int)
	 {if (biezacy<ile)
		 return elem[biezacy++];
	  return NULL;}

	 void Usun_kolekcje();
	 friend ostream& operator<<(ostream&,const TKol1&);
};

#endif
